// PokePicDlg.cpp : Implementierungsdatei
//



#include "stdafx.h"



#include "PokePic.h"
#include "PokePicDlg.h"
#include "InsertDialog.h"
#include "gfxreader.h"
//#include "GbaDraw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl 'Info'

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPokePicDlg Dialogfeld



CPokePicDlg::CPokePicDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPokePicDlg::IDD, pParent)
	, OpenFile(_T(""))
	, m_iPicID(0)
	, m_sMode(_T(""))
	, bAni(false)
	, m_bShiny(FALSE)
	, m_bBack(FALSE)
	, m_iTime(0)
	, pUnCmpFront(NULL)
	, pUnCmpBack(NULL)
	, pUnCmpNormal(NULL)
	, pUnCmpShiny(NULL)
	, m_bIcon(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPokePicDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_iPicID);
	DDX_Text(pDX, IDC_MODE, m_sMode);
	DDX_Check(pDX, IDC_SHINY, m_bShiny);
	DDX_Check(pDX, IDC_BACKPIC, m_bBack);
	DDX_Check(pDX, IDC_ICON, m_bIcon);
}

BEGIN_MESSAGE_MAP(CPokePicDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LoadFile, OnBnClickedLoadfile)
	ON_BN_CLICKED(IDC_VIEW, OnBnClickedView)
	ON_BN_CLICKED(IDC_NEXT, OnBnClickedNext)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_OPENBITMAP, OnBnClickedOpenbitmap)
	ON_BN_CLICKED(IDC_BUTTONEXPORT, OnBnClickedButtonexport)
	ON_BN_CLICKED(IDC_BCMP, OnBnClickedBcmp)
	ON_BN_CLICKED(IDC_BWETTER, OnBnClickedBwetter)
	ON_BN_CLICKED(IDC_ADVANCED, OnBnClickedAdvanced)
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)

END_MESSAGE_MAP()


// CPokePicDlg Meldungshandler

BOOL CPokePicDlg::OnInitDialog()
{
	CDialog::OnInitDialog();


	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	// TODO: Hier zustzliche Initialisierung einfgen
	GetDlgItem(IDC_VIEW)->EnableWindow(FALSE);
	GetDlgItem(IDC_NEXT)->EnableWindow(FALSE);
	m_iTime=0;
	GetDlgItem(IDC_OPENBITMAP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTONEXPORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_BACKPIC)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHINY)->EnableWindow(FALSE);
	GetDlgItem(IDC_BCMP)->EnableWindow(FALSE);
	GetDlgItem(IDC_ICON)->EnableWindow(FALSE);
	GetDlgItem(IDC_ADVANCED)->EnableWindow(FALSE);
	GetDlgItem(IDC_BWETTER)->EnableWindow(FALSE);


	SetTimer(ID_CLOCK_TIMER, 500, NULL);

	// beta protection
	/*
	CString Reg= "UaT";
	Reg.MakeReverse();
    Reg.MakeUpper();
	if(Reg.Find("TAU", 0)==-1)
		exit(1);
	MessageBox("This is a closed Beta version. It's watermarked. This copy is registered to:"+Reg);


	if(Reg.Find("T", 0)==-1 || Reg.Find("A", 0)==-1)
		exit(1);*/
	// beta protection
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CPokePicDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wenn Sie dem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch ausgefhrt.

void CPokePicDlg::OnPaint() 
{
	using namespace Gdiplus;
	
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext zum Zeichnen


		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Symbol in Clientrechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
		
	}
	else
	{

	CRect rect;

	GetClientRect(&rect);
	Rect rc(rect.left,rect.top,rect.right,rect.bottom);
    Bitmap bmp(rect.right,rect.bottom);

Graphics *graph = Graphics::FromImage(&bmp);

//graph->
CPaintDC dc(this);
//Graphics graphics(dc.m_hDC);
//graphics.
//ShowBitmap(&graphics);
//graphics.DrawImage(&bmp,rect.left,rect.top,rect.right,rect.bottom);	

if(!m_bmpBitmap[0].IsNull())
m_bmpBitmap[0].Draw(dc.m_hDC, 0, 0, m_bmpBitmap[0].GetWidth(), m_bmpBitmap[0].GetHeight());
if(!m_bmpBitmap[1].IsNull())
m_bmpBitmap[1].Draw(dc.m_hDC, 0, 64, m_bmpBitmap[1].GetWidth(), m_bmpBitmap[1].GetHeight());
if(!m_bmpBitmap[2].IsNull())
m_bmpBitmap[2].Draw(dc.m_hDC, 64, 0, m_bmpBitmap[2].GetWidth(), m_bmpBitmap[2].GetHeight());
if(!m_bmpBitmap[3].IsNull())
m_bmpBitmap[3].Draw(dc.m_hDC, 64, 64, m_bmpBitmap[3].GetWidth(), m_bmpBitmap[3].GetHeight());
if(!m_bmpBitmap[4].IsNull())
m_bmpBitmap[4].Draw(dc.m_hDC, 128, 32*(!bAni), m_bmpBitmap[4].GetWidth(), m_bmpBitmap[4].GetHeight());
if(!m_bmpBitmap[5].IsNull())
m_bmpBitmap[5].Draw(dc.m_hDC, 128, 32*(bAni), m_bmpBitmap[5].GetWidth(), m_bmpBitmap[5].GetHeight());

delete graph;

	}
	CDialog::OnPaint();
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CPokePicDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CPokePicDlg::OnBnClickedLoadfile()
{
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	static char BASED_CODE szFilter[] = "Gameboy Advance Roms (*.gba)|*.gba|All Files (*.*)|*.*||";
	CFileDialog dlg(TRUE, ".gba", OpenFile, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,  szFilter);
	
	
	if(dlg.DoModal() == IDOK)
	{
	OpenFile=dlg.GetPathName();

	char Buff[4];
	CFile File(OpenFile,CFile::modeRead);
	File.Seek(0xA8, CFile::begin);
	File.Read(Buff, 4);
	File.Close();
	CString Buffer;
	Buffer=Buff;
	if(Buffer.GetLength()-4>0)
	{
	Buffer.Delete(4, Buffer.GetLength()-4);
	}

//	MessageBox(Buffer);
	if(Buffer=="SAPP")
	{
		m_sMode="Mode: SAPP";
	UpdateData(FALSE);
	pokemon.Sapp=TRUE;
	}
	else if(Buffer=="RUBY")
	{
		m_sMode="Mode: RUBY";
	UpdateData(FALSE);
	pokemon.Sapp=FALSE;
	}
	else
	{
		m_sMode="Mode: UNKN";
	UpdateData(FALSE);
	GetDlgItem(IDC_VIEW)->EnableWindow(FALSE);
	GetDlgItem(IDC_NEXT)->EnableWindow(FALSE);

	GetDlgItem(IDC_OPENBITMAP)->EnableWindow(FALSE);
	GetDlgItem(IDC_BUTTONEXPORT)->EnableWindow(FALSE);
	GetDlgItem(IDC_BACKPIC)->EnableWindow(FALSE);
	GetDlgItem(IDC_SHINY)->EnableWindow(FALSE);
	GetDlgItem(IDC_BCMP)->EnableWindow(FALSE);
	return;
	}
	
	if(pokemon.ReadPic(0, OpenFile))
	{
//	MessageBox(dummy);
		/*
		CFile File("pokemongfx.dmp2", CFile::modeWrite);
		File.Write(pokemon.UnCmpData[0], 32);
		File.Write(pokemon.UnCmpData[1], 2048);
		File.Write(pokemon.UnCmpData[2], 32);
		File.Write(pokemon.UnCmpData[3], 2048);

		File.Close();	*/
	
GetDlgItem(IDC_VIEW)->EnableWindow(TRUE);
GetDlgItem(IDC_NEXT)->EnableWindow(TRUE);

	GetDlgItem(IDC_OPENBITMAP)->EnableWindow(TRUE);
	GetDlgItem(IDC_BUTTONEXPORT)->EnableWindow(TRUE);
	GetDlgItem(IDC_BACKPIC)->EnableWindow(TRUE);
	GetDlgItem(IDC_SHINY)->EnableWindow(TRUE);
	GetDlgItem(IDC_BCMP)->EnableWindow(TRUE);
	GetDlgItem(IDC_ICON)->EnableWindow(TRUE);
	GetDlgItem(IDC_ADVANCED)->EnableWindow(TRUE);
	GetDlgItem(IDC_BWETTER)->EnableWindow(TRUE);

	Wetter=0;

OnBnClickedView();   
//OnPaint();

	
	}
	else
		MessageBox("Error in Main :/");
	}
	
}



void CPokePicDlg::OnBnClickedView()
{
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
UpdateData(TRUE);
if(m_iPicID<0 || m_iPicID>439)
{
	MessageBox("PictureID does not exsist!", "Error", MB_OK |MB_ICONEXCLAMATION);
	return;
}
		if(pokemon.ReadPic(m_iPicID, OpenFile))
	{

		UpdatePointer();
		ExportPng(pUnCmpNormal, pUnCmpFront, &m_bmpBitmap[0], 8, 2048);
		ExportPng(pUnCmpNormal, pUnCmpBack, &m_bmpBitmap[1], 8, 2048);
		ExportPng(pUnCmpShiny, pUnCmpFront, &m_bmpBitmap[2], 8, 2048);
		ExportPng(pUnCmpShiny, pUnCmpBack, &m_bmpBitmap[3], 8, 2048);
		ExportPng(pUnCmpSmallPal, pUnCmpSmall, &m_bmpBitmap[4], 4, 0x200);
		ExportPng(pUnCmpSmallPal, &pUnCmpSmall[0x200], &m_bmpBitmap[5], 4, 0x200);
Invalidate(); 
	
	}
}

void CPokePicDlg::OnBnClickedNext()
{
	// TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	UpdateData(TRUE);
	m_iPicID++;
	UpdateData(FALSE);
OnBnClickedView();
}


void CPokePicDlg::OnTimer(UINT nIDEvent)
{
	// TODO: Fgen Sie hier Ihren Meldungsbehandlungscode ein, und/oder benutzen Sie den Standard.
bAni=bAni^1;
CRect rRect(128, 0, 128+32, 64);
rRect.NormalizeRect();
InvalidateRect(rRect);
	//m_iTime++;

	CDialog::OnTimer(nIDEvent);
}

void CPokePicDlg::OnBnClickedOpenbitmap()
{
	// Benachrichtigung ein.
 // Einen Filter fr das Dialogfeld ffnen erstellen
 static char szFilter[] =
 "PNG Files (*.png)|*.png|GIF Files (*.gif)|*.gif|Bitmap Files (*.bmp)|*.bmp||";
 // Dialogfeld File Open erzeugen
 CFileDialog dlgFile(TRUE, ".png", m_strBitmap,
 OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter);

 // Dialogfeld ffnen anzeigen und Ergebnis abfangen
 if (dlgFile.DoModal() == IDOK)
 {
 // Ausgewhlten Dateinamen ermitteln
 m_strBitmap = dlgFile.GetPathName();
 // Aktuelles Bild lschen
 m_bmpBitmap[0].Destroy();
 // Neues Bild laden
 m_bmpBitmap[0].Load(m_strBitmap);

UpdateData(TRUE);
 // function
if(m_bIcon)
{
	u8 dummypal[32];
	Bmp2Gba(&m_bmpBitmap[0], pUnCmpSmall, &dummypal[0]);
}
else
{
if(m_bBack)
{
	if(m_bShiny)
		Bmp2Gba(&m_bmpBitmap[0], pUnCmpBack, pUnCmpShiny);
	else
		Bmp2Gba(&m_bmpBitmap[0], pUnCmpBack, pUnCmpNormal);
}
else
{
	if(m_bShiny)
		Bmp2Gba(&m_bmpBitmap[0], pUnCmpFront, pUnCmpShiny);
	else
		Bmp2Gba(&m_bmpBitmap[0], pUnCmpFront, pUnCmpNormal);
}
}
 // Zweites Dialogfenster deaktivieren

		UpdatePointer();
		ExportPng(pUnCmpNormal, pUnCmpFront, &m_bmpBitmap[0], 8, 2048);
		ExportPng(pUnCmpNormal, pUnCmpBack, &m_bmpBitmap[1], 8, 2048);
		ExportPng(pUnCmpShiny, pUnCmpFront, &m_bmpBitmap[2], 8, 2048);
		ExportPng(pUnCmpShiny, pUnCmpBack, &m_bmpBitmap[3], 8, 2048);
		ExportPng(pUnCmpSmallPal, pUnCmpSmall, &m_bmpBitmap[4], 4, 0x200);
		ExportPng(pUnCmpSmallPal, &pUnCmpSmall[0x200], &m_bmpBitmap[5], 4, 0x200);
        Invalidate(); 
//Invalidate();
 }
}

 void CPokePicDlg::ShowBitmap(Graphics *graph)
 {

 }


 void CPokePicDlg::OnBnClickedButtonexport()
 {
	 
    CString Filename="mypicture.png";
	static char BASED_CODE szFilter[] = "PNG Files (*.png)|*.png|Gif Files (*.gif)|*.gif||";
	CFileDialog dlg(FALSE, ".png", Filename, 0,  szFilter);
	if(dlg.DoModal())
	{
		UpdateData(TRUE);
		int id=m_bShiny<<1 |m_bBack; 
		if(m_bIcon)
			id=4;
		m_bmpBitmap[id].Save(dlg.GetPathName(), GUID_NULL);

	}




 }

 int CPokePicDlg::ExportPng(u8 *pUnCmpPal, u8 *pUnCmpData, CImage *pImage, int rows, int size)
 {
	pImage->Destroy();
	int cols = size / (rows*64) * 2;
	pImage->Create(rows*8, cols*8, 8, 0);
	int x=0;
	int y=0;

	POINT point;
	point.x=x;
	point.y=y;

	u8 r[16];
	u8 g[16];
	u8 b[16];

	tagRGBQUAD colorref[16];

	for(int i=0; i<16; i++)
	{
		u16 palbuf=0 ;
		palbuf = pUnCmpPal[i*2+1]<<8;			
		palbuf = palbuf | pUnCmpPal[i*2];

		r[i] = ((palbuf & 0x1F) <<3);
		g[i] = ((palbuf >> 5) & 0x1F) <<3;
		b[i] = (((palbuf >> 10) & 0x1f) <<3);

		colorref[i].rgbBlue=(((palbuf >> 10) & 0x1f) <<3);
		colorref[i].rgbGreen=((palbuf >> 5) & 0x1F) <<3;
		colorref[i].rgbRed=((palbuf & 0x1F) <<3);
		colorref[i].rgbReserved=255;
	}

	pImage->SetColorTable(0, 16, colorref);
		


	for(int w=0; w<cols; w++)
	{

		for(int q=0; q<rows; q++)
		{

			for(int i=0; i<8; i++)
			{
		
				for(int j=0; j<4; j++)
				{
					unsigned char byte;
					unsigned char color1;
					unsigned char color2;
		
					byte = pUnCmpData[j+i*4+q*32+w*(32*rows)];
					color1 = (byte >> 4) & 0x0F;
					color2 = byte & 0x0F;
					pImage->SetPixel(point.x, point.y, RGB(r[color2], g[color2],b[color2]) );
					point.x++;
					pImage->SetPixel(point.x, point.y, RGB(r[color1], g[color1],b[color1])) ;
					point.x++;
				}
				point.y++;
				point.x-=8;
			}
			point.x+=8;
			point.y-=8;

		}
		point.x-=8*rows;
		point.y+=8;
	}
	return 0;
}

 void CPokePicDlg::OnBnClickedBcmp()
 {
	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
/*	 CString Message;
	 Message.Format("%d", pokemon.length);
	 MessageBox(Message);*/
	 
	 UpdateData(TRUE);
	 int ret;
	 CString Retcode;

	 pokemon.BIOS_LZ77CompWram(pokemon.UnCmpData[m_bBack], 2048*(pokemon.length/32), 1);
	 ret=pokemon.WritePic(m_iPicID, OpenFile, pokemon.filedata, m_bBack<<1|0, pokemon.filedatapos); 
	// ret=pokemon.WritePic(m_iPicID, OpenFile, pokemon.filedata, m_bShiny<<1|1, pokemon.filedatapos); 


     if(ret==12)
	 {
		 if(MessageBox("Image too big. Do you want to expand the ROM for further space?", "Error!", MB_YESNO|MB_ICONQUESTION)==IDYES)
			pokemon.WritePicEnd(m_iPicID, OpenFile, pokemon.filedata, m_bBack<<1|0, pokemon.filedatapos);
		 else
			 return;
	 }

	 pokemon.BIOS_LZ77CompWram(pokemon.UnCmpPal[m_bShiny], 32*(pokemon.length/32), 1);
	 ret=pokemon.WritePic(m_iPicID, OpenFile, pokemon.filedata, m_bShiny<<1|1, pokemon.filedatapos); 
     if(ret==12)
	 {
		 if(MessageBox("Pal too big. Do you want to expand the ROM for further space?", "Error!", MB_YESNO|MB_ICONQUESTION)==IDYES)
			pokemon.WritePicEnd(m_iPicID, OpenFile, pokemon.filedata, m_bBack<<1|1, pokemon.filedatapos);
		 else
			 return;
	 }


 }

 void CPokePicDlg::OnBnClickedBwetter()
 {
	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	 Wetter++;
	 if(Wetter>3)
		 Wetter=0;
	OnBnClickedView();
	Invalidate();
	

 }

 void CPokePicDlg::UpdatePointer(void)
 {
	pUnCmpFront = &pokemon.UnCmpData[0][2048*Wetter];
	pUnCmpBack = &pokemon.UnCmpData[1][2048*Wetter];
	pUnCmpNormal = &pokemon.UnCmpPal[0][32*Wetter];
	pUnCmpShiny = &pokemon.UnCmpPal[1][32*Wetter];

	pUnCmpSmall = &pokemon.UnCmpData[2][0];
	pUnCmpSmallPal = &pokemon.UnCmpPal[2+pokemon.smallpal[0]][0];
 }

 void CPokePicDlg::Bmp2Gba(CImage *Image, u8 *gbapic, u8 *gbapal)
 {
     int rows = Image->GetWidth()/8;
	 int cols = Image->GetHeight()/8;



	 
 tagRGBQUAD colorref[16];
 m_bmpBitmap[0].GetColorTable(0, 16, colorref);

 int gbacolor;
 UpdateData(TRUE);

 		/*	r[i] = ((palbuf & 0x1F) <<3);
			g[i] = ((palbuf >> 5) & 0x1F) <<3;
			b[i] = (((palbuf >> 10) & 0x1f) <<3);*/ 

for(int i=0; i<16; i++)
{
gbacolor = ((colorref[i].rgbBlue>>3)<<10) | (colorref[i].rgbGreen>>3)<<5 | (colorref[i].rgbRed>>3);

gbapal[1+(i*2)]=(gbacolor >> 8);
gbapal[(i*2)]=(gbacolor & 0xFF);


}
COLORREF color;

		POINT point;
		point.x=0;
		point.y=0;


for(int w=0; w<cols; w++)
{

for(int q=0; q<rows; q++)
{

		for(int i=0; i<8; i++)
		{
		
		for(int j=0; j<4; j++)
		{
		unsigned char byte;
		unsigned char color1;
		unsigned char color2;
		

		color=Image->GetPixel(point.x, point.y);
		COLORREF palcol;
		color1=0;
		for( int t=0; t<16; t++) 
		{
		palcol= colorref[t].rgbRed | colorref[t].rgbGreen << 8 | colorref[t].rgbBlue<<16;
        if(palcol == color)
			color1=t;

		}

		point.x++;
		color=Image->GetPixel(point.x, point.y);
    
		color2=0;
		for( int t=0; t<16; t++) 
		{
		palcol= colorref[t].rgbRed | colorref[t].rgbGreen << 8 | colorref[t].rgbBlue<<16;
        if(palcol == color)
			color2=t;
		}
	//	dc->SetPixel(point, RGB(r[color1], g[color1],b[color1])) ;

		
		gbapic[j+i*4+q*32+w*(32*rows)]=color2<<4 | color1;



		point.x++;
		}
        point.y++;
		point.x-=8;
		}
 point.x+=8;
 point.y-=8;

}
 point.x-=8*rows;
 point.y+=8;
}

 }
 void CPokePicDlg::OnBnClickedAdvanced()
 {
	//pokemon.dump(0x36D1F8, OpenFile);
	// pokemon.BIOS_LZ77CompWram(pokemon.UnCmpData[0], 1, 0);
	 CInsertDialog dlg;
	 dlg.Zoom=1;
	 dlg.m_iRows=1;
	 dlg.m_iSize=0;
	 dlg.m_sSize="Not Set";
	 dlg.OpenFile = OpenFile;
	 dlg.DoModal();
//	 dlg.doModal();


	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
 }

 void CPokePicDlg::OnBnClickedButton1()
 {
CAboutDlg dlg;
dlg.DoModal();
 }

 void CPokePicDlg::OnBnClickedTrainer()
 {
	 // TODO: Fgen Sie hier Ihren Kontrollbehandlungscode fr die Benachrichtigung ein.
	 //pokemon.

 }
